<?php

class GalleryShortcode
{
	private $galleryFunction;
	
	function __construct()
	{
		global $shortcode_tags;
		$this->galleryFunction = $shortcode_tags['gallery'];
	}
	
	//hopefully easier to ensure future compatability this way than a copy/paste of the WP 2.5 gallery_shortcode() function...
	function galleryShortcodeHandler($atts, $content = null)
	{
		global $pjStatus;
		$pjStatus=PJ_STATUS_GALLERY;
		if(!is_array($atts) || !array_key_exists('size', $atts))
		{
			$size=get_option('pj_gallery_size');
			if($size!='custom' && $size!='default')
			{
				$atts['size']=$size;
			}
			else if($size=='custom')
			{
				$atts['size']=get_option('pj_custom_width').'x'.get_option('pj_custom_height');
				if(get_option('pj_custom_crop')=='true')
				{ 
					$atts['size'].='xcrop';
				}
			}
		}
		if(!is_array($atts) || !array_key_exists('columns', $atts))
			$atts['columns']=get_option('pj_gallery_columns');
		if(is_array($atts) && array_key_exists('showchildren', $atts) && $atts['showchildren']=='true')
			$pjStatus=PJ_STATUS_CHILD_GALLERY;
		$output=call_user_func($this->galleryFunction, $atts);
		$pjStatus=PJ_STATUS_NONE;
		return $output;
	}

	function childGalleryQueryFilter($query)
	{
		global $pjStatus;
		if($pjStatus==PJ_STATUS_CHILD_GALLERY)
			echo 'QUERY: '.print_r($query).'<br />';
		return $query;
	}
}
?>