<?php
//only call these once
$thumbWidth = get_option('thumbnail_size_w');
$thumbHeight = get_option('thumbnail_size_h');
$thumbCrop = get_option('thumbnail_crop');
$medWidth = get_option('medium_size_w');
$medHeight = get_option('medium_size_h');

class ImageResize
{
	public function imageDownsizeFilter($crop, $id, $size)
	{
		global $thumbWidth, $thumbHeight, $thumbCrop, $medWidth, $medHeight;
		
		$imagedata = wp_get_attachment_metadata( $id );
		if($size == 'thumbnail') 
		{
			
			$width = $thumbWidth;
			$height = $thumbHeight;
			$crop = $thumbCrop;
		}
		else if($size == 'medium')
		{
			$width = $medWidth;
			$height = $medHeight;
			$crop=0;//false
		}
		else if(is_array($size))
		{
			$width=$size[0];
			$height=$size[1];
			$crop=0;
		}
		else if(preg_match('/^([0-9]+)x([0-9]+)x?(crop)?$/', $size, $matches))
		{
			$width=$matches[1];
			$height=$matches[2];
			$crop=0;
			if($matches[3]=='crop')
				$crop=1;//true
		}
		else
		{
			return false;
		}
		$originalImage = $imagedata['file'];
		$imageFile = $this->getFromCache($originalImage, $width, $height, $crop);
		
		//echo $size.'='.$width.'x'.$height.' Crop: '.$crop.'<br />';
		if($imageFile == null)
		{
			require_once(ABSPATH . 'wp-admin/admin-functions.php');
			$imageFile = image_resize($originalImage, $width, $height, $crop, null, PJ_CACHE_PATH, get_option('pj_jpeg_quality')); // $suffix=null, $dest_path=null, $jpeg_quality=90
		}
		$img_info = getimagesize($imageFile);
		$img_url = PJ_CACHE_URL.basename($imageFile);

		return array( $img_url, $img_info[0], $img_info[1] );
	}
	
	private function getFromCache($file, $width, $height, $crop)
	{
		$info = getimagesize($file);
		$dims = image_resize_dimensions($info[0], $info[1], $width, $height, $crop);
		list($dst_x, $dst_y, $src_x, $src_y, $dst_w, $dst_h, $src_w, $src_h) = $dims;
		
		$info = pathinfo($file);
		//$dir = $info['dirname'];
		$ext = $info['extension'];
		$name = basename($file, '.'.$ext);
		$suffix = $dst_w.'x'.$dst_h;
		$thumbName = $name.'-'.$suffix.'.'.$ext;
		if(file_exists(PJ_CACHE_PATH.$thumbName))
		{
			return PJ_CACHE_PATH.$thumbName;
		}
		
		return null;
	}
}
?>